/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.biojava.ontology.format.triples.lexer;

import java.io.*;
import java.util.*;
import org.biojava.ontology.format.triples.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(int line, int pos) { return new TNamespace(line, pos); }
    Token new1(int line, int pos) { return new TImport(line, pos); }
    Token new2(int line, int pos) { return new TAs(line, pos); }
    Token new3(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new4(int line, int pos) { return new TLeftElipse(line, pos); }
    Token new5(int line, int pos) { return new TRightElipse(line, pos); }
    Token new6(int line, int pos) { return new TLeftCurly(line, pos); }
    Token new7(int line, int pos) { return new TRightCurly(line, pos); }
    Token new8(int line, int pos) { return new TLeftSquare(line, pos); }
    Token new9(int line, int pos) { return new TRightSquare(line, pos); }
    Token new10(int line, int pos) { return new TComma(line, pos); }
    Token new11(int line, int pos) { return new TDot(line, pos); }
    Token new12(String text, int line, int pos) { return new TName(text, line, pos); }
    Token new13(String text, int line, int pos) { return new TVariable(text, line, pos); }
    Token new14(String text, int line, int pos) { return new TNumber(text, line, pos); }
    Token new15(String text, int line, int pos) { return new TComment(text, line, pos); }
    Token new16(String text, int line, int pos) { return new TUserComment(text, line, pos); }
    Token new17(String text, int line, int pos) { return new TQuotedString(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {12, 12, 3}, {13, 13, 4}, {32, 32, 5}, {34, 34, 6}, {35, 35, 7}, {40, 40, 8}, {41, 41, 9}, {44, 44, 10}, {46, 46, 11}, {48, 57, 12}, {65, 90, 13}, {91, 91, 14}, {93, 93, 15}, {95, 95, 16}, {97, 97, 17}, {98, 104, 18}, {105, 105, 19}, {106, 109, 18}, {110, 110, 20}, {111, 122, 18}, {123, 123, 21}, {125, 125, 22}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 9, 1}, {10, 10, 23}, {12, 32, -2}, },
            {{9, 32, -2}, },
            {{0, 33, 24}, {35, 65535, 24}, },
            {{0, 9, 25}, {10, 10, 26}, {11, 12, 25}, {13, 13, 27}, {14, 65535, 25}, },
            {},
            {},
            {},
            {},
            {{48, 57, 12}, },
            {{48, 57, 28}, {65, 90, 29}, {95, 95, 30}, {97, 122, 31}, },
            {},
            {},
            {{48, 57, 32}, {65, 90, 33}, {95, 95, 34}, {97, 122, 35}, },
            {{48, 95, -15}, {97, 114, 31}, {115, 115, 36}, {116, 122, 31}, },
            {{48, 122, -15}, },
            {{48, 95, -15}, {97, 108, 31}, {109, 109, 37}, {110, 122, 31}, },
            {{48, 95, -15}, {97, 97, 38}, {98, 122, 31}, },
            {{0, 124, 39}, {125, 125, 40}, {126, 65535, 39}, },
            {},
            {{9, 32, -2}, },
            {{34, 34, 41}, },
            {{0, 65535, -9}, },
            {},
            {{10, 10, 42}, },
            {{48, 122, -15}, },
            {{48, 122, -15}, },
            {{48, 122, -15}, },
            {{48, 122, -15}, },
            {{48, 122, -18}, },
            {{48, 122, -18}, },
            {{48, 122, -18}, },
            {{48, 122, -18}, },
            {{48, 122, -15}, },
            {{48, 95, -15}, {97, 111, 31}, {112, 112, 43}, {113, 122, 31}, },
            {{48, 108, -21}, {109, 109, 44}, {110, 122, 31}, },
            {{0, 65535, -23}, },
            {},
            {},
            {},
            {{48, 95, -15}, {97, 110, 31}, {111, 111, 45}, {112, 122, 31}, },
            {{48, 95, -15}, {97, 100, 31}, {101, 101, 46}, {102, 122, 31}, },
            {{48, 95, -15}, {97, 113, 31}, {114, 114, 47}, {115, 122, 31}, },
            {{48, 114, -19}, {115, 115, 48}, {116, 122, 31}, },
            {{48, 95, -15}, {97, 115, 31}, {116, 116, 49}, {117, 122, 31}, },
            {{48, 111, -39}, {112, 112, 50}, {113, 122, 31}, },
            {{48, 122, -15}, },
            {{48, 95, -15}, {97, 97, 51}, {98, 122, 31}, },
            {{48, 95, -15}, {97, 98, 31}, {99, 99, 52}, {100, 122, 31}, },
            {{48, 100, -46}, {101, 101, 53}, {102, 122, 31}, },
            {{48, 122, -15}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {3, 3, 3, 3, 3, 3, -1, -1, 4, 5, 10, 11, 14, 12, 8, 9, 13, 12, 12, 12, 12, 6, 7, 3, -1, -1, 16, 16, 12, 12, 12, 12, 13, 13, 13, 13, 2, 12, 12, -1, 15, 17, 16, 12, 12, 12, 12, 12, 12, 1, 12, 12, 12, 0, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
